ConRO.Monk = {};
ConRO.Monk.CheckTalents = function()
end
local ConRO_Monk, ids = ...;

function ConRO:EnableRotationModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Monk.CheckTalents;
	if mode == 1 then
		self.Description = "Monk [Brewmaster - Tank]";
		self.NextSpell = ConRO.Monk.Brewmaster;
		self.ToggleHealer();
	end;
	if mode == 2 then
		self.Description = "Monk [Mistweaver - Healer]";
		self.NextSpell = ConRO.Monk.Mistweaver;
		self.ToggleHealer();
	end;
	if mode == 3 then
		self.Description = "Monk [Windwalker - Melee]";
		self.NextSpell = ConRO.Monk.Windwalker;
		self.ToggleDamage();
	end;
	self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
	self.lastSpellId = 0;
end

function ConRO:EnableDefenseModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Monk.CheckTalents;
	if mode == 1 then
		self.NextDef = ConRO.Monk.BrewmasterDef;
	end;
	if mode == 2 then
		self.NextDef = ConRO.Monk.MistweaverDef;
	end;
	if mode == 3 then
		self.NextDef = ConRO.Monk.WindwalkerDef;
	end;
end

function ConRO:UNIT_SPELLCAST_SUCCEEDED(event, unitID, lineID, spellID)
	if unitID == 'player' then
		self.lastSpellId = spellID;
	end
end

function ConRO.Monk.Brewmaster(_, timeShift, currentSpell, gcd, tChosen)
--Resources
	local energy					 						= UnitPower('player', Enum.PowerType.Energy);
	local energyMax 										= UnitPowerMax('player', Enum.PowerType.Energy);

--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilities
	local proRDY											= ConRO:AbilityReady(ids.Bm_Ability.Provoke, timeShift);
	local bsRDY												= ConRO:AbilityReady(ids.Bm_Ability.BlackoutStrike, timeShift);
		local bcBUFF											= ConRO:Aura(ids.Bm_Buff.BlackoutCombo, timeShift);
	local bofRDY											= ConRO:AbilityReady(ids.Bm_Ability.BreathofFire, timeShift);
	local ksRDY												= ConRO:AbilityReady(ids.Bm_Ability.KegSmash, timeShift);
		local ksDEBUFF											= ConRO:TargetAura(ids.Bm_Debuff.KegSmash, timeShift);
	local tpRDY												= ConRO:AbilityReady(ids.Bm_Ability.TigerPalm, timeShift);
	local shsRDY 											= ConRO:AbilityReady(ids.Bm_Ability.SpearHandStrike, timeShift);
	local isbRDY											= ConRO:AbilityReady(ids.Bm_Ability.IronskinBrew, timeShift);
		local isbCharges, isbMaxCharges							= ConRO:SpellCharges(ids.Bm_Ability.IronskinBrew);	
		local isbBUFF											= ConRO:Aura(ids.Bm_Buff.IronskinBrew, timeShift);
		
	local cbRDY												= ConRO:AbilityReady(ids.Bm_Talent.ChiBurst, timeShift);
	local cwRDY												= ConRO:AbilityReady(ids.Bm_Talent.ChiWave, timeShift);
	local rjwRDY											= ConRO:AbilityReady(ids.Bm_Talent.RushingJadeWind, timeShift);
		local rjwBUFF											= ConRO:Aura(ids.Bm_Buff.RushingJadeWind, timeShift);	
	
--Conditions
	local Close 											= CheckInteractDistance("target", 3);
	
--Indicators
	ConRO:AbilityInterrupt(ids.Bm_Ability.SpearHandStrike, shs and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	
	ConRO:AbilityTaunt(ids.Bm_Ability.Provoke, proRDY and (not ConRO:InRaid() or (ConRO:InRaid() and ConRO:TarYou())));
	
--Rotations
	if bcBUFF and tChosen[ids.Bm_Talent.BlackoutCombo] and ConRO.lastSpellId == ids.Bm_Ability.BlackoutStrike then
		if ksRDY and isbCharges <= 2 then
			return ids.Bm_Ability.KegSmash;
		elseif tpRDY then
			return ids.Bm_Ability.TigerPalm;
		end
	end
	
	if isbRDY and not isbBUFF and isbCharges == isbMaxCharges then
		return ids.Bm_Ability.IronskinBrew;
	end
	
	if ksRDY then
		return ids.Bm_Ability.KegSmash;
	end
	
	if bsRDY then
		return ids.Bm_Ability.BlackoutStrike;
	end

	if bofRDY then
		return ids.Bm_Ability.BreathofFire;
	end

	if rjwRDY and not rjwBUFF then
		return ids.Bm_Talent.RushingJadeWind;
	end

	if tpRDY and energy >= 65 and not tChosen[ids.Bm_Talent.BlackoutCombo] then
		return ids.Bm_Ability.TigerPalm;
	end 

	if cbRDY then
		return ids.Bm_Talent.ChiBurst;
	end		

	if cwRDY then
		return ids.Bm_Talent.ChiWave;
	end
return nil;
end

function ConRO.Monk.BrewmasterDef(_, timeShift, currentSpell, gcd, tChosen)
--Resources
	local energy					 						= UnitPower('player', Enum.PowerType.Energy);
	local energyMax 										= UnitPowerMax('player', Enum.PowerType.Energy);

--Abilities
	local pbRDY												= ConRO:AbilityReady(ids.Bm_Ability.PurifyingBrew, timeShift);
	local isbRDY											= ConRO:AbilityReady(ids.Bm_Ability.IronskinBrew, timeShift);
		local isbBUFF											= ConRO:Aura(ids.Bm_Buff.IronskinBrew, timeShift + 1);			
		local brewCharges, brewMaxCharges						= ConRO:SpellCharges(ids.Bm_Ability.IronskinBrew);	
		local hsDEBUFF											= ConRO:Aura(ids.Bm_Debuff.HighStagger, timeShift, 'HARMFUL');		
	local zmRDY												= ConRO:AbilityReady(ids.Bm_Ability.ZenMeditation, timeShift);		
	local fbRDY												= ConRO:AbilityReady(ids.Bm_Ability.FortifyingBrew, timeShift);
	local ehRDY												= ConRO:AbilityReady(ids.Bm_Ability.ExpelHarm, timeShift);	

	local heRDY												= ConRO:AbilityReady(ids.Bm_Talent.HealingElixir, timeShift);	

--Conditions
	local playerPh 											= ConRO:PercentHealth('player');	

--Indicators
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	
--Rotations
	if pbRDY and hsDEBUFF and brewCharges >= 1 then
		return ids.Bm_Ability.PurifyingBrew;
	end
	
	if isbRDY and (not isbBUFF or brewCharges == brewMaxCharges) then
		return ids.Bm_Ability.IronskinBrew;
	end

	if heRDY and playerPh <= 80 then
		return ids.Bm_Talent.HealingElixir;
	end	
	
	if ehRDY and playerPh <= 50 then
		return ids.Bm_Ability.ExpelHarm;
	end	

	if fbRDY then
		return ids.Bm_Ability.FortifyingBrew;
	end
	
return nil;
end

function ConRO.Monk.Mistweaver(_, timeShift, currentSpell, gcd, tChosen)
--Resources
	local mana					 							= UnitPower('player', Enum.PowerType.Mana);
	local manaMax 											= UnitPowerMax('player', Enum.PowerType.Mana);
	
--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);

--Abilities
	local tp 												= ConRO:AbilityReady(ids.Mw_Ability.TigerPalm, timeShift);
		local totmBuff, totmCount								= ConRO:Aura(ids.Mw_Buff.TeachingsoftheMonastery, timeShift);
	local rsk, rskCD, rskMCD								= ConRO:AbilityReady(ids.Mw_Ability.RisingSunKick, timeShift);
	local bok 												= ConRO:AbilityReady(ids.Mw_Ability.BlackoutKick, timeShift);
	
--Conditions	
	local isEnemy 											= ConRO:TarHostile();
	local Close 											= CheckInteractDistance("target", 3);
	
--Rotations
	if isEnemy then
		if rsk then
			return ids.Mw_Ability.RisingSunKick;
		end
		if bok and not rsk and rskCD > rskMCD - 6 then
			return ids.Mw_Ability.BlackoutKick;
		end		
		
		if tp and (not totmBuff or totmCount < 3) then
			return ids.Mw_Ability.TigerPalm;
		end
	end
return nil;
end

function ConRO.Monk.MistweaverDef(_, timeShift, currentSpell, gcd, tChosen)

	
return nil;
end

function ConRO.Monk.Windwalker(_, timeShift, currentSpell, gcd, tChosen)
--Resources
	local energy					 						= UnitPower('player', Enum.PowerType.Energy);
	local energyMax 										= UnitPowerMax('player', Enum.PowerType.Energy);
	local chi 												= UnitPower('player', Enum.PowerType.Chi);
	local chiMax 											= UnitPowerMax('player', Enum.PowerType.Chi);	
	
--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);

--Abilities
	local cjLightning 										= ConRO:AbilityReady(ids.Ww_Ability.CracklingJadeLightning, timeShift);
		local tecBuff, tecStacks								= ConRO:Form(ids.Ww_Form.TheEmperorsCapacitor);
	local shs 												= ConRO:AbilityReady(ids.Ww_Ability.SpearHandStrike, timeShift);
	local fof, fofCD 										= ConRO:AbilityReady(ids.Ww_Ability.FistsofFury, timeShift);
	local tp 												= ConRO:AbilityReady(ids.Ww_Ability.TigerPalm, timeShift);
	local rsk, rskCD										= ConRO:AbilityReady(ids.Ww_Ability.RisingSunKick, timeShift);
	local bok 												= ConRO:AbilityReady(ids.Ww_Ability.BlackoutKick, timeShift);
	local tod 												= ConRO:AbilityReady(ids.Ww_Ability.TouchofDeath, timeShift);
		local todDebuff											= ConRO:TargetAura(ids.Ww_Debuff.TouchofDeath, timeShift);
	local sef												= ConRO:AbilityReady(ids.Ww_Ability.StormEarthandFire, timeShift);
		local sefBuff											= ConRO:Aura(ids.Ww_Buff.StormEarthandFire, timeShift);
		local sefCharges, sefMaxCharges							= ConRO:SpellCharges(ids.Ww_Ability.StormEarthandFire);	
	local sck 												= ConRO:AbilityReady(ids.Ww_Ability.SpinningCraneKick, timeShift);
		local motcDebuff										= ConRO:TargetAura(ids.Ww_Debuff.MarkoftheCrane, timeShift);
	
	local ee 												= ConRO:AbilityReady(ids.Ww_Talent.EnergizingElixir, timeShift);	
	local wdp, wdpCD 										= ConRO:AbilityReady(ids.Ww_Talent.WhirlingDragonPunch, timeShift);
	local cwave 											= ConRO:AbilityReady(ids.Ww_Talent.ChiWave, timeShift);
	local sere 												= ConRO:AbilityReady(ids.Ww_Talent.Serenity, timeShift);
	local rjw 												= ConRO:AbilityReady(ids.Ww_Talent.RushingJadeWind, timeShift);
	local cburst 											= ConRO:AbilityReady(ids.Ww_Talent.ChiBurst, timeShift);
	local fotwtRDY 											= ConRO:AbilityReady(ids.Ww_Talent.FistoftheWhiteTiger, timeShift);
	local invokeRDY 										= ConRO:AbilityReady(ids.Ww_Talent.InvokeXuentheWhiteTiger, timeShift);

	local serBuff, _, serDur								= ConRO:Aura(ids.Ww_Buff.Serenity, timeShift);
	local bkBuff 											= ConRO:Aura(ids.Ww_Buff.BlackoutKick, timeShift);

--Conditions
	local incombat 											= UnitAffectingCombat('player');
	local Close 											= CheckInteractDistance("target", 3);	
	
--Indicators
	ConRO:AbilityInterrupt(ids.Ww_Ability.SpearHandStrike, shs and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	
	ConRO:AbilityBurst(ids.Ww_Ability.TouchofDeath, tod and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Ww_Talent.InvokeXuentheWhiteTiger, invokeRDY and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Ww_Ability.StormEarthandFire, sef and not sefBuff and not tChosen[ids.Ww_Talent.Serenity] and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Ww_Talent.Serenity, sere and fofCD == 0 and ConRO_BurstButton:IsVisible());

--Rotations
	if ee and energy <= 20 and chi <= 3 then
		return ids.Ww_Talent.EnergizingElixir;
	end
	
	if serBuff then
		if rsk and ConRO.lastSpellId ~= ids.Ww_Ability.RisingSunKick then
			return ids.Ww_Ability.RisingSunKick;
		end
		
		if fof and serDur >= 9 and currentSpell ~= ids.Ww_Ability.FistsofFury then
			return ids.Ww_Ability.FistsofFury;
		end
		
		if bok and ConRO.lastSpellId ~= ids.Ww_Ability.BlackoutKick then
			return ids.Ww_Ability.BlackoutKick;
		end	

		if fof and currentSpell ~= ids.Ww_Ability.FistsofFury then
			return ids.Ww_Ability.FistsofFury;
		end
		
		if tChosen[ids.Ww_Talent.FistoftheWhiteTiger] then
			if fotwtRDY then
				return ids.Ww_Talent.FistoftheWhiteTiger;
			end
		else
			if sck then
				return ids.Ww_Ability.SpinningCraneKick;
			end		
		end
	else
		if ConRO_SingleButton:IsVisible() then
			if fotwtRDY and chi < 3 and energy >= energyMax - 15 then
				return ids.Ww_Talent.FistoftheWhiteTiger;
			end
			
			if tp and chi <= 4 and energy >= energyMax - 15 and ConRO.lastSpellId ~= ids.Ww_Ability.TigerPalm then
				return ids.Ww_Ability.TigerPalm;
			end
			
			if incombat and sef and not sefBuff and not tChosen[ids.Ww_Talent.Serenity] and ConRO_FullButton:IsVisible() then
				return ids.Ww_Ability.StormEarthandFire;
			end
			
			if incombat and sere and fofCD == 0 and ConRO_FullButton:IsVisible() then
				return ids.Ww_Talent.Serenity;
			end

			if incombat and invokeRDY and ConRO_FullButton:IsVisible() then
				return ids.Ww_Talent.InvokeXuentheWhiteTiger;
			end
			
			if incombat and tod and ConRO_FullButton:IsVisible() then
				return ids.Ww_Ability.TouchofDeath;
			end
			
			if wdp and fofCD > 0 and rskCD > 0 then
				return ids.Ww_Talent.WhirlingDragonPunch;
			end
		
			if rsk then
				return ids.Ww_Ability.RisingSunKick;
			end	
			
			if fof and currentSpell ~= ids.Ww_Ability.FistsofFury then
				return ids.Ww_Ability.FistsofFury;
			end	
			
			if cburst and chi <= 4 and currentSpell ~= ids.Ww_Talent.ChiBurst then
				return ids.Ww_Talent.ChiBurst;
			end
			
			if fotwtRDY and chi < 3 then
				return ids.Ww_Talent.FistoftheWhiteTiger;
			end

			if bok and ConRO.lastSpellId ~= ids.Ww_Ability.BlackoutKick then
				return ids.Ww_Ability.BlackoutKick;
			end	
			
			if cwave then
				return ids.Ww_Talent.ChiWave;
			end
			
			if tp and ConRO.lastSpellId ~= ids.Ww_Ability.TigerPalm then
				return ids.Ww_Ability.TigerPalm;
			end
		else
			if rjw then
				return ids.Ww_Ability.RushingJadeWind;
			end
			
			if incombat and sef and not sefBuff and not tChosen[ids.Ww_Talent.Serenity] and ConRO_FullButton:IsVisible() then
				return ids.Ww_Ability.StormEarthandFire;
			end
			
			if incombat and sere and fofCD == 0 and ConRO_FullButton:IsVisible() then
				return ids.Ww_Talent.Serenity;
			end

			if incombat and invokeRDY and ConRO_FullButton:IsVisible() then
				return ids.Ww_Talent.InvokeXuentheWhiteTiger;
			end
			
			if incombat and tod and ConRO_FullButton:IsVisible() then
				return ids.Ww_Ability.TouchofDeath;
			end
			
			if wdp and fofCD > 0 and rskCD > 0 then
				return ids.Ww_Talent.WhirlingDragonPunch;
			end

			if fof and currentSpell ~= ids.Ww_Ability.FistsofFury then
				return ids.Ww_Ability.FistsofFury;
			end
			
			if rsk and tChosen[ids.Ww_Talent.WhirlingDragonPunch] and not wdp and wdpCD < 3 then
				return ids.Ww_Ability.RisingSunKick;
			end	

			if cburst and chi < 5 and currentSpell ~= ids.Ww_Talent.ChiBurst then
				return ids.Ww_Talent.ChiBurst;
			end	
			
			if sck and motcDebuff then
				return ids.Ww_Ability.SpinningCraneKick;
			end			

			if rsk then
				return ids.Ww_Ability.RisingSunKick;
			end	

			if bok and ConRO.lastSpellId ~= ids.Ww_Ability.BlackoutKick then
				return ids.Ww_Ability.BlackoutKick;
			end
			
			if fotwtRDY then
				return ids.Ww_Talent.FistoftheWhiteTiger;
			end
			
			if cwave then
				return ids.Ww_Talent.ChiWave;
			end

			if tp and (chi == 0 or ConRO.lastSpellId ~= ids.Ww_Ability.TigerPalm) then
				return ids.Ww_Ability.TigerPalm;
			end
		end
	end
return nil;
end

function ConRO.Monk.WindwalkerDef(_, timeShift, currentSpell, gcd, tChosen)
--Resources
	local energy 											= UnitPower('player', Enum.PowerType.Energy);
	local chi 												= UnitPower('player', Enum.PowerType.Chi);
--Abilities
	local tok 												= ConRO:AbilityReady(ids.Ww_Ability.TouchofKarma, timeShift);

--Rotations	
	if tok then
		return ids.Ww_Ability.TouchofKarma;
	end
return nil;
end
